<?php

require_once ('class.doap.php');

class dcDOAP
{
  var $project_id;
  var $con;
  var $encoding;
  var $user_id;
  var $lang;
  var $doap_filename;
  
 //constructor
 
 function dcDOAP($user_id,$project_id,$lang,$encoding)
 {          
   $this->user_id  = $user_id;
   $this->lang = $lang;
   $this->encoding = $encoding;
   $this->project_id= $project_id;             
 }
 
 function _retrieveData()
 { 
   global $con,$rs_doap;
   
   $doap_content ='';
   
   $rs_doap = $con->select('SELECT * FROM '.DB_PREFIX.'doap WHERE user_id ="'.$this->user_id.'"');
       
 if($con->error() === false || !$rs_doap->isEmpty())
 {          
     $data = $rs_doap->getData();   
     
     foreach($data as $projects)
     {      
       $doap = new doap($this->encoding,$this->lang);
       $date  = strtotime($projects['date']);
       $doap->set_output_date(date('Y-m-d',$date));
       $doap->set_output_lang($projects['user_doap_lang']);
       $doap->set_output_name($projects['user_doap_project_name']);
       $doap->set_output_version($projects['user_doap_project_version']);
       $doap->set_output_name_release($projects['user_doap_release_name']);
       $date_project  = strtotime(trim($projects['user_doap_project_date']));
       $doap->set_output_date_project(date('Y-m-d',$date_project));
       $doap->set_output_homepage($projects['user_doap_url_homepage']);
       $doap->set_output_desc($projects['user_doap_description']);    
       $doap->set_output_shortdesc($projects['user_doap_shortdesc']);   
       $doap->set_output_wiki($projects['user_doap_url_wiki']);
       $doap->set_output_weblog($projects['user_doap_url_blog'],$projects['user_doap_url_blog'].'/rss.php');
       $doap->set_output_buglist($projects['user_doap_url_buglist']);
       $doap->set_output_mailinglist($projects['user_doap_url_mailinglist']);
       $doap->set_output_screenshots($projects['user_doap_url_screenshots']);            
       $doap->set_output_programming_language($projects['user_doap_programming_language']);
       $doap->set_output_os($projects['user_doap_os']);    
       $doap->set_output_license($projects['user_doap_license']);     
       $doap->set_output_project_type($projects['user_doap_project_type']);
       $doap->set_output_repos1($projects['user_doap_url_repos1']);
       $doap->set_output_repos2($projects['user_doap_url_repos2']);
       $doap->set_output_repos3($projects['user_doap_url_repos3']);
       $doap->set_output_base($projects['user_doap_url_base']);
       $doap->set_output_logo($projects['user_doap_url_logo']);    
       $doap->set_output_pubkey($projects['user_doap_url_key']);                 
       $doap->set_output_maintainer_name($projects['user_doap_maintainer_name']);
       $doap->set_output_maintainer_nickname($projects['user_doap_maintainer_nickname']);
       $doap->set_output_maintainer_mbox_sha1($projects['user_doap_maintainer_email']);    
       $doap->set_output_maintainer_foaf($projects['user_doap_maintainer_foaf_url']);               
       $doap->set_output_developers($projects['user_doap_developers']);
       $doap->set_output_documenters($projects['user_doap_documenters']);
       $doap->set_output_translators($projects['user_doap_translators']);
     
       $doap->doap_rdf = $doap->get_output_all_project();
              
       if($this->encoding == 'UTF-8' || $this->encoding == 'utf-8')
       {
          $doap_content = utf8_encode($doap->doap_rdf);   
       
       }else{
   
          $doap_content = $doap->doap_rdf;
       }
       
        $this->doap_filename = $_SERVER['DOCUMENT_ROOT'] . dc_app_url . '/' .'doap-'.$projects['user_doap_project_name'].'.rdf';
	
        $doap->save_doap_file($this->doap_filename,$doap_content);
      }     
  }else{
   
   //print_r($rs_doap); //debug
   $errors ='<div class="erreur"><p><strong>' . __('DOAP File(s) creation Error(s)') .$con->error().' :</strong></p>' . '</div>'; 
  }
 }
 
 //delete the DOAP File with the name doap-doap_name_project.rdf
 
 function _eraseDOAPFile()
 {
   global $doap;
  
   $filename = $_SERVER['DOCUMENT_ROOT'].'/'.dc_app_url.'/'.'doap-'.$this->project_id.'.rdf';      
   
   if (is_file($filename))  
      return unlink($filename);
  }
}
?>
