<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****
#
# last modified by Harisson 02/10/04
#

class doap
{

 //doap rdf var
 var $doap_rdf;
 
 //external vars
 //var $project_id;
 var $encoding;
 var $doap_lang;
 
 //doap base vars
 var $doap_lang;
 var $doap_name;
 var $doap_version; 
 var $doap_date;
 var $doap_homepage;
 var $doap_wiki;
 var $doap_weblog;
 var $doap_weblog_rss;
 var $doap_license;
 var $doap_pubkey;
 var $doap_desc;
 var $doap_shortdesc;
 var $doap_screenshots;  
 var $doap_logo;
 var $doap_name_release; 
 var $doap_date_project;
 
 var $doap_programming_language;
 var $doap_maintainer_name;
 var $doap_maintainer_nickname;
 var $doap_maintainer_mbox_sha1;
 var $doap_maintainer_foaf;
  
 //doap optional vars
 var $doap_mailinglist;
 var $doap_buglist;
 var $doap_translators ;
 var $doap_documenters ;
 var $doap_developers ;
 
 //doap var project type for repository recognition
 var $doap_project_type;
  
 //doap repository vars (note default value create doap:download-page attributes : pkg.gz,zip,tar.gz,base_url)
 var $doap_repos1;
 var $doap_repos2;
 var $doap_repos3;
 var $doap_base;    
 var $doap_os;
  
 /*constructor*/
 function doap($encoding='UTF-8',$doap_lang='en')
 {
   $this->encoding = $encoding;
   $this->doap_lang= $doap_lang;
 }
  
/*setter functions */

  function set_output_lang($doap_lang)
  {
    $this->doap_lang=$doap_lang;
  }

  function set_output_name($doap_name)
  {
    $this->doap_name = $doap_name;
  }

  function set_output_version($doap_version)
  {
    $this->doap_version=$doap_version;
  }

  function set_output_name_release($doap_name_release)
  {
    $this->doap_name_release=$doap_name_release;
  }

  function set_output_date_project($doap_date_project)
  {
    $this->doap_date_project=$doap_date_project;
  }

  function set_output_date($doap_date)
  {
    $this->doap_date=$doap_date;
  }

  function set_output_homepage($doap_homepage)
  {
    $this->doap_homepage=$doap_homepage;
  }

  function set_output_wiki($doap_wiki)
  { 
    $this->doap_wiki=$doap_wiki;
  }
  
  function set_output_weblog($doap_weblog,$doap_weblog_rss)
  { 
    $this->doap_weblog=$doap_weblog;
    $this->doap_weblog_rss=$doap_weblog_rss;
  }
  
  function set_output_license($doap_license)
  {
    $this->doap_license=$doap_license;
  }
  
  function set_output_logo($doap_logo)
  {
    $this->doap_logo=$doap_logo;
  }
  
  function set_output_pubkey($doap_pubkey)
  {
    $this->doap_pubkey=$doap_pubkey;
  }

  function set_output_desc($doap_desc)
  {
    $this->doap_desc=$doap_desc;
  }

  function set_output_shortdesc($doap_shortdesc)
  {
    $this->doap_shortdesc=$doap_shortdesc;
  }

  function set_output_screenshots($doap_screenshots)
  {
    $this->doap_screenshots=$doap_screenshots;
  }

  function set_output_programming_language($doap_programming_language)
  {
    $this->doap_programming_language=$doap_programming_language;
  }

  function set_output_maintainer_name($doap_maintainer_name)
  {
    $this->doap_maintainer_name=$doap_maintainer_name;
  }

  function set_output_maintainer_nickname($doap_maintainer_nickname)
  {
   $this->doap_maintainer_nickname=$doap_maintainer_nickname;
  }

  function set_output_maintainer_mbox_sha1($doap_maintainer_mbox_sha1)
  {
   $this->doap_maintainer_mbox_sha1=$doap_maintainer_mbox_sha1;
  }

  function set_output_maintainer_foaf($doap_maintainer_foaf)
  {
    $this->doap_maintainer_foaf=$doap_maintainer_foaf;
  }

  function set_output_mailinglist($doap_mailinglist)
  {
    $this->doap_mailinglist=$doap_mailinglist;
  }

  function set_output_buglist($doap_buglist)
  {
    $this->doap_buglist=$doap_buglist;
  }

  function set_output_translators($doap_translators)
  {
    $this->doap_translators=$doap_translators;
  }

  function set_output_documenters($doap_documenters)
  {
    $this->doap_documenters=$doap_documenters;
  }

  function set_output_developers($doap_developers)
  {
    $this->doap_developers=$doap_developers;
  }

  function set_output_project_type($doap_project_type)
  { 
    $this->doap_project_type=$doap_project_type;
  }

  function set_output_repos1($doap_repos1)
  {
    $this->doap_repos1=$doap_repos1;
  }

  function set_output_repos2($doap_repos2)
  {
    $this->doap_repos2=$doap_repos2;
  }

  function set_output_repos3($doap_repos3)
  {
   $this->doap_repos3=$doap_repos3;
  }

  function set_output_base($doap_base)
  {
    $this->doap_base=$doap_base;
  }

  function set_output_os($doap_os)
  {
    $this->doap_os=$doap_os;
  }

/*getter functions*/

  /*doap_ouput_headers*/
  function get_doap_output_xml_header()
  {
      return  "<?xml version=\"1.0\" encoding=\"" . $this->encoding ."\"?>\n";		   
  }
  
  function get_doap_output_header_ns()
  {
    $result  ="<rdf:RDF\n";
    $result .="xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n"; 
    $result .="xmlns:rdfs=\"http://www.w3.org/2000/01/rdf-schema#\"\n";
    $result .="xmlns:doap=\"http://usefulinc.com/ns/doap#\"\n"; 
    $result .="xmlns:foaf=\"http://xmlns.com/foaf/0.1#\"\n";
    $result .="xmlns:wot=\"http://xmlns.com/wot/0.1/\"\n";
    
    if($this->doap_weblog !=null)
    {
      $result .="xmlns:rss=\"http://purl.org/rss/1.0/\"\n";
    }
        
    $result .="xml:lang=\"".$this->doap_lang."\">\n";	   
    $result .="<rdf:Description rdf:about=\"\">\n";
    $result .="\t<admin:generatorAgent rdf:resource=\"http://harisson.free.fr/plugins/dcDOAP\" />\n";
    $result .="</rdf:Description>\n";
 
   return $result;   
  }
  
/*doap_ouput_end*/ 
  function get_doap_output_end()
  {   
      return "</rdf:RDF>";  
  }

 
  function get_doap_output_base()
  {
  
        $doap_value  ="<doap:Project>\n";
        $doap_value .="\t<doap:name>".$this->doap_name."</doap:name>\n";
	
	$doap_value .="\t<doap:release>\n";
	$doap_value .="\t\t<doap:Version>\n";
	$doap_value .="\t\t\t<doap:name>".$this->doap_name_release."</doap:name>\n";
	$doap_value .="\t\t\t<doap:created>".$this->doap_date_project."</doap:created>\n";
	$doap_value .="\t\t\t<doap:revision>".$this->doap_version."</doap:revision>\n";
	$doap_value .="\t\t</doap:Version>\n";
	$doap_value .="\t</doap:release>\n";	
	$doap_value .="\t<doap:homepage rdf:resource=\"".$this->doap_homepage."\" />\n";
	$doap_value .="\t<doap:created>".$this->doap_date."</doap:created>\n";
	$doap_value .="\t<doap:description xml:lang=\"".$this->doap_lang."\">".$this->doap_desc."</doap:description>\n";
	$doap_value .="\t<doap:shortdesc xml:lang=\"".$this->doap_lang."\">".$this->doap_shortdesc."</doap:shortdesc>\n";
	
	if($this->doap_wiki != null)
	{
	  $doap_value .="\t<doap:wiki rdf:resource=\"".$this->doap_wiki."\" />\n";	
	}
	
	$proglang = preg_split("/,/",$this->doap_programming_language);
	
	foreach($proglang as $array_langage)
	{
	  $doap_value .="\t<doap:programming-language>".$array_langage."</doap:programming-language>\n";
	}	
				     
	$doap_value .="\t<doap:maintainer>\n";
	$doap_value .="\t\t<foaf:Person>\n";
	$doap_value .="\t\t\t<foaf:name>".$this->doap_maintainer_name."</foaf:name>\n";
	$doap_value .="\t\t\t<foaf:nick>".$this->doap_maintainer_nickname."</foaf:nick>\n";
	$doap_value .="\t\t\t<foaf:mbox_sha1sum>".$this->doap_maintainer_mbox_sha1."</foaf:mbox_sha1sum>\n";
	$doap_value .="\t\t\t<rdfs:seeAlso rdf:resource=\"".$this->doap_maintainer_foaf."\" />\n";
        
	if($this->doap_weblog != null)
	{
	  $doap_value .="\t\t\t<foaf:weblog>\n";
	  $doap_value .="\t\t\t\t<foaf:Document rdf:about=\"".$this->doap_weblog."\">\n";
          $doap_value .="\t\t\t\t\t<rdfs:seeAlso>\n";
          $doap_value .="\t\t\t\t\t\t<rss:channel rdf:about=\"".$this->doap_weblog_rss."\" />\n";
          $doap_value .="\t\t\t\t\t</rdfs:seeAlso>\n";
          $doap_value .="\t\t\t\t</foaf:Document>\n";
	  $doap_value .="\t\t\t</foaf:weblog>\n";
        }
	
	$doap_value .="\t\t</foaf:Person>\n";
	$doap_value .="\t</doap:maintainer>\n";
	
     return $doap_value;			     
   }
      
   function get_doap_output_end_base()   
   {
     return "</doap:Project>\n";
   }
   
   function get_doap_output_buglist()
   {   
     return ($this->doap_buglist != '')?"\t<doap:bug-database rdf:resource=\"".$this->doap_buglist."\" />\n":"";  
   }
   
   function get_doap_output_mailinglist()
   {
     return ($this->doap_mailinglist != '')? "\t<doap:mailing-list rdf:resource=\"".$this->doap_mailinglist."\" />\n":""; 
   }
   
   function get_doap_output_screenshots()
   {
     return ($this->doap_screenshots != '')? "\t<doap:screenshots rdf:resource=\"".$this->doap_screenshots."\" />\n":""; 
   }
   function get_doap_output_logo()
   {
     return ($this->doap_logo != '')? "\t<doap:logo rdf:resource=\"".$this->doap_logo."\" />\n":""; 
   }
   
   function get_doap_output_pubkey()
   {            
     return ($this->doap_pubkey != '')?"\t\t<wot:assurance rdf:resource=\"".$this->doap_pubkey."\" />\n":"";
   }
   
   function get_doap_output_license()   
   {
   
     $doap_value='';
      
     $licenses = preg_split("/,/",$this->doap_license);
      
      if(!empty($licenses))
      { 
        foreach($licenses as $arry_license)
        {
          $doap_value .= "\t<doap:license rdf:resource=\"".$arry_license."\" />\n";
        }
      }   
     return $doap_value; 
   }
   
   function get_doap_ouput_repository()
   {
     
     $type = $this->doap_project_type;
      
      switch($type)
      {
        case 'CVS':
	{	
	    $doap_value  ="\t<doap:repository>\n";
            $doap_value .="\t\t<doap:CVSRepository>\n";
            $doap_value .="\t\t\t<doap:anon-root>".$this->repos1."</doap:anon-root>\n";
            $doap_value .="\t\t\t<doap:module>".$this->repos2."</doap:module>\n";
            $doap_value .="\t\t\t<doap:browse rdf:resource=\"".$this->repos3."\" />\n";
            $doap_value .="\t\t</doap:CVSRepository>\n";
            $doap_value .="\t</doap:repository>\n";
	} 
	case 'SVN' :
	{
	   $doap_value  ="\t<doap:repository>\n";
           $doap_value .="\t\t<doap:SVNRepository>\n";
           $doap_value .="\t\t\t<doap:location rdf:resource=\"".$this->doap_base_url."\" />\n";
           $doap_value .="\t\t\t<doap:browse rdf:resource=\"".$this->doap_repos3."\" />\n";
           $doap_value .="\t\t</doap:SVNRepository>\n";
           $doap_value .="\t</doap:repository>\n";
	}
	case 'ARCH' :
	{
	   $doap_value  ="\t<doap:repository>\n";
	   $doap_value .="\t\t<doap:ArchRepository>\n";
           $doap_value .="\t\t\t<doap:location rdf:resource=\"".$this->doap_base_url."\"/>\n";
           $doap_value .="\t\t\t<doap:module>".$this->doap_repos2."</doap:module>\n";
           $doap_value .="\t\t</doap:ArchRepository>\n";
           $doap_value .="\t</doap:repository>\n";
	}
	case 'BITKEEPER' :
	{
	   $doap_value  ="\t<doap:repository>\n";
	   $doap_value .="\t\t<<doap:BKRepository>\n";
           $doap_value .="\t\t\t<doap:location rdf:resource=\"".$this->doap_base_url."\" />\n";
           $doap_value .="\t\t\t<doap:browse rdf:resource=\"".$this->doap_repos3."\" />\n";
           $doap_value .="\t\t</doap:BKRepository>\n";
	   $doap_value .="\t</doap:repository>\n";
	}
	default :
	{
	   $doap_value ="\t<doap:download-page rdf:resource=\"".$this->doap_base."\" />\n";
	}
      }
      return $doap_value;
    }
   
   function get_doap_output_developers()
   {      
    $doap_value='';
      
    $devs = preg_split("/,/",$this->doap_developers);
      
    if(!empty($devs))
    { 
        foreach($devs as $arry_dev)
        {
          $doap_value .="\t<doap:developer>\n";
	  $doap_value .="\t\t<foaf:Person>\n";
	  $doap_value .="\t\t\t<foaf:name>".$arry_dev."</foaf:name>\n";
          $doap_value .="\t\t</foaf:Person>\n";
	  $doap_value .="\t</doap:developer>\n";
        }
     }
      return $doap_value;
   }
   
   function get_doap_output_documenters()
   {
      $doap_value='';
      $docs = preg_split("/,/",$this->doap_documenters);
      
     if(!empty($docs))
     { 
        foreach($docs as $arry_doc)
        {      
         $doap_value  .="\t<doap:documenter>\n";
	 $doap_value  .="\t\t<foaf:Person>\n";
	 $doap_value  .="\t\t\t<foaf:name>".$arry_doc."</foaf:name>\n";
         $doap_value  .="\t\t</foaf:Person>\n";
	 $doap_value  .="\t</doap:documenter>\n";      
        }
      }
      return $doap_value;
   }
   
   function get_doap_output_translators()
   {
      $doap_value = '';
      $trans = preg_split("/,/",$this->doap_translators);
   
    if(!empty($trans) && $this->doap_translators != null && $this->doap_translators != '')
    {    
      foreach($trans as $arry_trans)
      {           
        $doap_value .="\t<doap:translator>\n";
	$doap_value .="\t\t<foaf:Person>\n";
	$doap_value .="\t\t\t<foaf:name>".$arry_trans."</foaf:name>\n";
        $doap_value .="\t\t</foaf:Person>\n";
	$doap_value .="\t</doap:translator>\n";      
      }
     } 
      return $doap_value;
   }
   
   function get_doap_output_os()
   {                     
      $doap_value = '';
      $os = preg_split("/,/",$this->doap_os);
   
      if(!empty($os))
      {    
        foreach($os as $arry_os)
        {           
          $doap_value .="\t<doap:os>".$arry_os."</doap:os>\n";
        }
      }       
    
     return $doap_value;
   }

   function get_output_all_project()
   {   
      $doap_value  = $this->get_doap_output_xml_header();
      $doap_value .= $this->get_doap_output_header_ns();
      $doap_value .= $this->get_doap_output_base();
      $doap_value .= $this->get_doap_output_buglist();
      $doap_value .= $this->get_doap_output_mailinglist();
      $doap_value .= $this->get_doap_output_screenshots();
      $doap_value .= $this->get_doap_output_os();
      $doap_value .= $this->get_doap_output_license();
      $doap_value .= $this->get_doap_output_pubkey();
      $doap_value .= $this->get_doap_output_logo();
      $doap_value .= $this->get_doap_output_developers();
      $doap_value .= $this->get_doap_output_documenters();
      $doap_value .= $this->get_doap_output_translators();
      $doap_value .= $this->get_doap_ouput_repository();			      
      $doap_value .= $this->get_doap_output_end_base();
      $doap_value .= $this->get_doap_output_end();
      
    return $doap_value;  
   }
  
  function _generateFilename() 
  {
     return $_SERVER["PHP_SELF"].'./doap.rdf';
  }
	
  function save_doap_file($filename='',$doap_rdf)
  {
    if ($filename=="") {
	$filename = $this->_generateFilename();
	}
    
     $doapFile = fopen($filename, "w+");
     
     if ($doapFile) {
		      fputs($doapFile,$doap_rdf);
		      fclose($doapFile);
	            } else {
			$err='<br /><b>Error creating doap file, please check write permissions.</b><br />';
		    }
   }  
  
  
  function save_doap_files($file_array,$doap_rdf)
  {
    if (empty($filename)) {
	  return false;
	}
    
    foreach($file_array as $filename)
    {
      $doapFile = fopen($filename, "w+");
     
      if ($doapFile) {
		      fputs($doapFile,$doap_rdf);
		      fclose($doapFile);
	            } else {
			$err='<br /><b>Error creating doap file, please check write permissions.</b><br />';
		    }
     }
   }
   
   function delete_doap_file($filename='')
   {
      if (is_file($filename)) 
      {   
      return unlink($filename);
      }
   }	
}

?>
