<?php

//include_once dirname(__FILE__) . '/sha1.php';
require_once dirname(__FILE__) . '/../../../inc/classes/class.multipage.php';
require_once dirname(__FILE__) .'/class.dcdoap.php';

$plugin_url = 'tools.php?p=dcDOAP';
$plugin_name = 'dcDOAP';
$img_warning = './images/check_off.png';

$strReq = 'SHOW TABLES LIKE \''.DB_PREFIX.'%s\' ';

$rs = $con->select(sprintf($strReq,'doap'));
$installed= !$rs->isEmpty();
  
//lecture du fichier conf.ini

$conf_file = dirname(__FILE__).'/conf.ini';
iniFile::read($conf_file);

if ((isset($_GET['mode']) && ($_GET['mode'] == 'add')) || (isset($_POST['add']))) {
    $mode = 'add';    
} elseif ((isset($_GET['mode']) && ($_GET['mode'] == 'edit')) || (isset($_POST['edit']))) {
    $mode = 'edit';    
} elseif (isset($_POST['delete'])) {
    $mode = 'delete';
} elseif (!$installed) {
    $mode='install';
} elseif ((isset($_GET['mode']) && ($_GET['mode'] == 'uninstall')) ||(isset($_POST['uninstall']))) {
    $mode = 'uninstall';        
} else {
    $mode = 'list';
}

if (!isset($_REQUEST['page'])) {
    $_REQUEST['page'] = 1;
}

function doap_line($doap_user,$nb) 
{
  global $plugin_url;
  $date = strtotime($doap_user['date']); 
  $date_project = strtotime($doap_user['user_doap_project_date']);
  //print_r($doap_user); //debug
  
  $project_type = htmlspecialchars($doap_user['user_doap_project_type']);
  
  switch($project_type)
  {
  
    case 'DOTCLEAR':
    {
      $doap_repos1='<strong>'.__('Url to pkg.gz plugin').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_repos1']).'<br />';
      $doap_repos2='<strong>'.__('Url to zip plugin').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_repos2']).'<br />';
      $doap_repos3='<strong>'.__('Url to tar.gz plugin').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_repos3']).'<br />';
      $doap_base_url='<strong>'.__('Base Url to plugin archives').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_base']).'<br />';
      break;
    }
    case 'CVS':
    {
      $doap_repos1='<strong>'.__('Anonymous server connection string').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_repos1']).'<br />';
      $doap_repos2='<strong>'.__('Module name of the source code eg co modulename').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_repos2']).'<br />';
      $doap_repos3='<strong>'.__('Web browser interface url of the repository').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_repos3']).'<br />';
      $doap_base_url='<strong>'.__('Base Url to cvs project archives').' : '.'</strong>'.__('No').'<br />';
      break;
    }
    case 'SVN':
    {
      $doap_repos1='<strong>'.__('Anonymous server connection string').' : '.'</strong>'.__('No').'<br />';
      $doap_repos2='<strong>'.__('Module name of the source code').' : '.'</strong>'.__('No').'<br />';
      $doap_repos3='<strong>'.__('Web browser interface url of the repository').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_repos3']).'<br />';
      $doap_base_url='<strong>'.__('Base Url to svn project archives').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_base']).'<br />';
      break;
    }
    case 'ARCH':
    {
      $doap_repos1='<strong>'.__('Anonymous server connection string').' : '.'</strong>'.__('No').'<br />';
      $doap_repos2='<strong>'.__('Module name of the source code eg co modulename').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_repos2']).'<br />';
      $doap_repos3='<strong>'.__('Web browser interface url of the repository').' : '.'</strong>'.__('No').'<br />';
      $doap_base_url='<strong>'.__('Base Url to arch project archives').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_base']).'<br />';
      break;
    }
    case 'BITKEEPER':
    {
      $doap_repos1='<strong>'.__('Anonymous server connection string').' : '.'</strong>'.__('No').'<br />';
      $doap_repos2='<strong>'.__('Module name of the source code').' : '.'</strong>'.__('No').'<br />';
      $doap_repos3='<strong>'.__('Web browser interface url of the repository').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_repos3']).'<br />';
      $doap_base_url='<strong>'.__('Base Url to bitkeeper project archives').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_base']).'<br />';
      break;
    }
  }

  $isblog = !empty($doap_user['user_doap_url_blog'])?htmlspecialchars($doap_user['user_doap_url_blog']):__('No Blog');
  $iswiki = !empty($doap_user['user_doap_url_wiki'])?htmlspecialchars($doap_user['user_doap_url_wiki']):__('No Wiki');
  $isbuglist = !empty($doap_user['user_doap_url_buglist'])?htmlspecialchars($doap_user['user_doap_url_buglist']):__('No bug-list');
  $ismailinglist = !empty($doap_user['user_doap_url_mailinglist'])?htmlspecialchars($doap_user['user_doap_url_mailinglist']):__('No mailing-list');
  $ispubkey = !empty($doap_user['user_doap_url_key'])?htmlspecialchars($doap_user['user_doap_url_key']):__('No DOAP pubkey');
  $islogo = !empty($doap_user['user_doap_url_logo'])?htmlspecialchars($doap_user['user_doap_url_logo']):__('No logo');
  $istrans = !empty($doap_user['user_doap_translators'])?htmlspecialchars($doap_user['user_doap_translators']):__('No translator(s)');
  
  $result_line = '<div class="ligne">' .
           '<h3 class="ligneTitre">' .
           '<a href="#" onclick="openClose(\'doap' . $doap_user['user_doap_id'] .'\',0); return false;">' .
           '<img src="images/plus.png" id="img_doap' . $doap_user['user_doap_id'] . '" alt="montre/masquer" title="montre/masquer">' .
           '</a>&nbsp;&nbsp;' .
           '<a href="' . $plugin_url . '&amp;mode=edit&amp;user_doap_id=' . $doap_user['user_doap_id'] . '" title="Edit : '.$doap_user['user_doap_id'] .'">' .
	    htmlspecialchars($doap_user['user_doap_project_name']) .'&nbsp;&nbsp; : '.$doap_user['user_doap_maintainer_nickname'] .'</a>' .
           '</h3>' .
           '<p class="ligneInfo">' . date('d-m-Y H:i:s', $date) . ' - ' . htmlspecialchars($doap_user['user_id']) . '</p>' .
           '<div style="display: none;" id="doap' . $doap_user['user_doap_id'] .'" class="comment">'.'<br />'.
	   '<h3 class="ligneTitre">'.__('Your doap project profile').'</h3>'.
	   '<p>'.	   
	   '<strong>'.__('Project language').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_lang']).'<br />' . 
	   '<strong>'.__('Project name').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_project_name']).'<br />'.
	   '<strong>'.__('Project release name').' : '.'</strong>'. htmlspecialchars($doap_user['user_doap_release_name']).'<br />'.
	   '<strong>'.__('Project date creation').' : '.'</strong>'.date('d-m-Y',$date_project).'<br />'.
	   '<strong>'.__('Project version/revision').' : '.'</strong>'. htmlspecialchars($doap_user['user_doap_project_version']).'<br />'.
	   '<strong>'.__('Project DOAP file creation date').' : '.'</strong>'.date('d-m-Y H:i:s', $date).'<br />'.
	   '<strong>'.__('Project homepage').' : '.'</strong>'. htmlspecialchars($doap_user['user_doap_url_homepage']).'<br />'.	   
	   '<strong>'.__('Description').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_description']).'<br />'.
	   '<strong>'.__('Short Description').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_shortdesc']).'<br />'.
	   '<strong>'.__('Url to wiki').' : '.'</strong>'.$iswiki.'<br />'.
	   '<strong>'.__('Url to blog').' : '.'</strong>'.$isblog.'<br />'.
	   '<strong>'.__('Url to bug-list/bug-database').' : '.'</strong>'.$isbuglist.'<br />'.
	   '<strong>'.__('Url to mailing-list').' : '.'</strong>'.$ismailinglist.'<br />'.
	   '<strong>'.__('Programming Language').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_programming_language']).'<br />'.
	   '<strong>'.__('Os specific').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_os']).'<br />'.
	   '<strong>'.__('License').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_license']).'<br />'.	   
	   '<strong>'.__('Url to project public key').' : '.'</strong>'.$ispubkey.'<br />'.
	   '<strong>'.__('Maintainer name').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_maintainer_name']).'<br />'.
	   '<strong>'.__('Maintainer nickname').' : '.'</strong>'. htmlspecialchars($doap_user['user_doap_maintainer_nickname']).'<br />'.
	   '<strong>'.__('Maintainer mbox_sha1').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_maintainer_email']).'<br />'.
	   '<strong>'.__('Maintainer foaf url').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_maintainer_foaf_url']).'<br />'.
	   '<strong>'.__('Developer(s) name').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_developers']).'<br />'.
	   '<strong>'.__('Documenter(s) name').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_documenters']).'<br />'.
	   '<strong>'.__('Translator(s) name').' : '.'</strong>'.$istrans.'<br />'.
	   '<strong>'.__('Project repository type').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_project_type']).'<br />'.	    
	   $doap_repos1.
	   $doap_repos2.
	   $doap_repos3.
	   $doap_base_url.
	   '<strong>'.__('Project logo url').' : '.'</strong>'.$islogo.'<br />'.
	   '<strong>'.__('Project screenshots url').' : '.'</strong>'.htmlspecialchars($doap_user['user_doap_url_screenshots']).'<br />'.
	     
	   '</p>'.'<br />';	   
	   	   
  return $result_line;     
}

//switch mode
switch($mode) { 

  case 'list':
    	{
	  buffer::str('<ul class="user-info"><li class="ui-name">'.$plugin_name.' : '.'&nbsp;'.helpLink('index&amp;plugin=dcDOAP', 'field delete_tables').__('uninstall table(s)').'</li><li class="ui-logout">'.
	  '<img src="'.$img_warning.'" alt="'.__('DANGER : irreversible action, be careful please').'" title="'.__('DANGER : irreversible action, be careful please').'" />&nbsp;'.
	  '<a href="'.$plugin_url.'&amp;mode=uninstall" title="uninstall '.$plugin_name.' table(s)" onclick="return window.confirm(\'' .
	   __('CAUTION !!! CAUTION !!! Are you sure you want delete tables from').' '.$plugin_name.' : '.__('You will loose all recorded data from this plugin').'\')">'.
	   __('Delete').' '.$plugin_name.'</a></li></ul>');
	  	  
	  buffer::str('<h2>'.$plugin_name.'</h2>');
	  	  	  
	  $hasfoaf = false;		  
	  
	  $sql = 'SELECT COUNT(*) AS `nb_doapentry` FROM `' . DB_PREFIX . 'doap`';
          $rscount = $con->select($sql);
          $nb_doapentry = $rscount->field('nb_doapentry');
	  $max_pages = ceil($nb_doapentry / dcdoap_nb_displayed_item);
          $env = (!empty($_GET['env']) && $_GET['env'] <= $max_pages) ? $_GET['env'] : 1;
	  
	  $sql_doap='SELECT * FROM `' . DB_PREFIX . 'doap` ORDER BY `date` DESC LIMIT ' .
	  (($env - 1) * dcdoap_nb_displayed_item) . ',' .dcdoap_nb_displayed_item ;	
	  $rs_doap = $con->select($sql_doap);
	
	  $lum = new multipage($env, 'doap_line', $rs_doap->getData(), $nb_doapentry,dcdoap_nb_displayed_item);
          $lum->setOption('html_links', '<p>' . __('Page(s)') . ' : %s</p>');
          $lum->setOption('html_prev', '&lt;' . __('prev. page'));
          $lum->setOption('html_next', __('next page') . '&gt;');
          $lum->setOption('html_empty', '<p><strong>' . __('No entry yet') . '</strong></p>');
		  
        // JavaScript
        $js_openCloseAll = $h_script = '';
	
        $data = $rs_doap->getData();
	
        if (!empty($data)) {
            $ids = array();
            foreach($data as $key => $value) {
                $ids[] = 'doap' . $value['user_doap_id'];		
            }        
	    
        	$h_script =
        	'<script type="text/javascript">' . "\n" .
        	"js_ids = new Array('" . implode("','" , $ids) . "');\n" .
        	"window.onload = function() { mOpenClose(js_ids, -1); }\n" .
        	"</script>\n";
        	
        	$js_openCloseAll =
        	'<p class="small"><a href="#" onclick="mOpenClose(js_ids, 1)">' . __('show all') . '</a> - ' .
        	'<a href="#" onclick="mOpenClose(js_ids, -1)">' . __('hide all') . '</a></p>';			     
         }        
         	  	 
	 
	 buffer::str('<a href="' . $plugin_url . '&amp;mode=add">' . __('Add a new DOAP project profile') . '</a><br /><br />');
	 	  	  	  	  	  	  	 	  
         buffer::str($lum->getLinks());
         buffer::str($h_script);
         buffer::str($js_openCloseAll);
         buffer::str($lum->getPage());        
         buffer::str($lum->getLinks());
	 
	 break;
    }

    case 'add':
    case 'edit':
    {
        buffer::str('<img src="images/ico_retour.png" alt="' . __('Back to list') . '"><a href="' . $plugin_url . '">' . __('Back to list') . '</a>');
          
        // If a foaf profile has been posted we add or edit it
        if (isset($_POST['doap_submited'])) {
            
            // We check the user input
            $errors = array();
	    
	    if (trim($_POST['doap_name']) == '') {
                $errors[] = __('Project Name required');
            }
            if (trim($_POST['doap_version']) == '') {
                $errors[] = __('Project version required');
            }	    
	    if (trim($_POST['doap_description']) == '') {
                $errors[] = __('Project description required');
            }
	    if (!is_array($_POST['doap_programming_language'])) {
                $errors[] = __('Project programming_language required');		
            }	    
	    if (!is_array($_POST['doap_license'])) {
                $errors[] = __('Project license required');
            }
	    if (trim($_POST['doap_release_name']) == '') {
                $errors[] = __('Project release name required');
            }
	    if (trim($_POST['doap_project_date']) == '') {
                $errors[] = __('Project date creation required');
            }	    
            if (trim($_POST['doap_maintainer_name']) == '') {
                $errors[] = __('Project maintainer name required');
            }
	    if (trim($_POST['doap_maintainer_email']) == '') {
                $errors[] = __('Project maintainer email required');
            }
            if (trim($_POST['doap_homepage']) == '') {
                $errors[] = __('Project homepage url version required');
            }	    
	    if (trim($_POST['doap_url_wiki']) == '' && trim($_POST['doap_url_blog']) == '') {
                $errors[] = __('Project either wiki or blog url required');
            }           
	    if (trim($_POST['doap_url_logo']) == '') {
                $errors[] = __('Project logo url required');
            }
	    if (trim($_POST['doap_developers']) == '') {
                $errors[] = __('Project developers name required');
            }
	    if (trim($_POST['doap_documenters']) == '') {
                $errors[] = __('Project documenters name required');
            } 
	    if(trim($_POST['doap_project_type']) == 'CVS' && !empty($_POST['doap_url_base']))
	    {
	        $errors[] = __('The base_url field must be empty for CVS');
	    }	    	    
	    if( (trim($_POST['doap_project_type']) == 'BITKEEPER' || trim($_POST['doap_project_type']) == 'SVN' || trim($_POST['doap_project_type']) == 'ARCH') && !empty($_POST['doap_url_repos1']))
	    {
	        $errors[] = __('The doap_url_repos1 field must be empty for BITKEEPER,SVN and ARCH');
	    }  
	    if((trim($_POST['doap_project_type']) == 'BITKEEPER' || trim($_POST['doap_project_type']) == 'SVN')  && !empty($_POST['doap_url_repos2']))
	    {
	        $errors[] = __('The doap_url_repos2 field must be empty for BITKEEPER,SVN');
	    }
	    if(trim($_POST['doap_project_type']) == 'ARCH' && !empty($_POST['doap_url_repos3']))
	    {
	        $errors[] = __('The doap_url_repos3 field must be empty for ARCH');
	    }
            if(trim($_POST['doap_project_type']) == 'DOTCLEAR' && ((empty($_POST['doap_url_repos1'])) || empty($_POST['doap_url_repos2']) ||
	       empty($_POST['doap_url_repos3']) ||  empty($_POST['doap_url_base'])))
	    {
	        $errors[] = __('All fields repos1,repos2,repos3,url_base required for Dotclear plugins');
	    }
	    	    
	    if (count($errors) == 0) {
	    			  
		$user_id = $_SESSION['sess_user_id'];               				
								
		$user_doap_lang  = trim($_POST['doap_lang']);
                $user_doap_project_name = trim($_POST['doap_name']);
		$user_doap_release_name = trim($_POST['doap_release_name']);
		$user_doap_project_date = strtotime(trim($_POST['doap_project_date']));		
                $user_doap_project_version    = trim($_POST['doap_version']);
                $user_doap_url_homepage = trim($_POST['doap_homepage']);
                $user_doap_description = trim($_POST['doap_description']);
		$user_doap_shortdesc  = trim($_POST['doap_shortdesc']);				
	        $user_doap_url_wiki = trim($_POST['doap_url_wiki']);
		$user_doap_url_blog = trim($_POST['doap_url_blog']);
		$user_doap_url_buglist = trim($_POST['doap_url_buglist']);
		$user_doap_url_mailinglist = trim($_POST['doap_url_mailinglist']);
		
		$user_doap_url_screenshots  = !empty($_POST['doap_screenshots'])?trim($_POST['doap_screenshots']):'';
		
		$proglang=$_POST['doap_programming_language'];				
		$user_doap_programming_language=implode(",",$proglang);
				
		$user_doap_os = !empty($_POST['doap_os'])?trim($_POST['doap_os']):'Any';
		
		$license = $_POST['doap_license'];
		$user_doap_license = implode(",",$license);
		
		$user_doap_project_type = trim($_POST['doap_project_type']);
		$user_doap_url_repos1 = trim($_POST['doap_url_repos1']);
		$user_doap_url_repos2 = trim($_POST['doap_url_repos2']);
		$user_doap_url_repos3 = trim($_POST['doap_url_repos3']);
		$user_doap_url_base = trim($_POST['doap_url_base']);
		$user_doap_url_logo = trim($_POST['doap_url_logo']);
		$user_doap_url_key = trim($_POST['doap_url_key']);
		$user_doap_maintainer_name = trim($_POST['doap_maintainer_name']);
		$user_doap_maintainer_nickname= trim($_POST['doap_maintainer_nickname']);
		$user_doap_maintainer_email = sha1(trim($_POST['doap_maintainer_email']));
		$user_doap_maintainer_foaf_url = trim($_POST['doap_maintainer_foaf_url']);
		$user_doap_developers = trim($_POST['doap_developers']);
		$user_doap_documenters = trim($_POST['doap_documenters']);
		$user_doap_translators = trim($_POST['doap_translators']);
		            
                if ($mode == 'add') {
                    $sql = 'INSERT INTO ' . DB_PREFIX . 'doap (`user_id`, `user_doap_id`,`date`, `user_doap_lang`,`user_doap_project_name`, `user_doap_release_name`,`user_doap_project_date`,`user_doap_project_version`,
		           `user_doap_url_homepage`,`user_doap_description`,`user_doap_shortdesc`,`user_doap_url_wiki`,`user_doap_url_blog`,`user_doap_url_buglist`,`user_doap_url_mailinglist`,`user_doap_url_screenshots`,
			   `user_doap_programming_language`,`user_doap_os`,`user_doap_license`,`user_doap_project_type`,`user_doap_url_repos1`,`user_doap_url_repos2`,`user_doap_url_repos3`,`user_doap_url_base`,
			   `user_doap_url_logo`,`user_doap_url_key`,`user_doap_maintainer_name`,`user_doap_maintainer_nickname`,`user_doap_maintainer_email`,`user_doap_maintainer_foaf_url`,
			   `user_doap_developers`,`user_doap_documenters`,`user_doap_translators`) VALUES (
			   "'.$con->escapeStr($user_id).'", ' .
			   'NULL,' .
                           '"' . date('Y-m-d H:i:s', time()) . '", ' .
                           '"' .$con->escapeStr($_POST['doap_lang']) . '", "' .
                           $con->escapeStr($_POST['doap_name']) . '", "' .
			   $con->escapeStr($_POST['doap_release_name']) . '", "' .
			   date('Y-m-d',$user_doap_project_date) . '", "' .
                           $con->escapeStr($_POST['doap_version']) . '", "' .
                           $con->escapeStr($_POST['doap_homepage']) . '", "' .
                           $con->escapeStr($_POST['doap_description']) . '", "' .
			   $con->escapeStr($_POST['doap_shortdesc']) . '", "' .
			   $con->escapeStr($_POST['doap_url_wiki']) . '", "' .
			   $con->escapeStr($_POST['doap_url_blog']) . '", "' .
			   $con->escapeStr($user_doap_url_buglist) . '", "' .
			   $con->escapeStr($user_doap_url_mailinglist) . '", "' .
			   $con->escapeStr($user_doap_url_screenshots) . '", "' .
			   $con->escapeStr($user_doap_programming_language) . '", "' .
			   $con->escapeStr($user_doap_os) . '", "' .
			   $con->escapeStr($user_doap_license) . '", "' .			   
			   $con->escapeStr($_POST['doap_project_type']) . '", "' .
			   $con->escapeStr($_POST['doap_url_repos1']) . '", "' .
			   $con->escapeStr($_POST['doap_url_repos2']) . '", "' .			   
			   $con->escapeStr($_POST['doap_url_repos3']) . '", "' .
			   $con->escapeStr($_POST['doap_url_base']) . '", "' .
			   $con->escapeStr($_POST['doap_url_logo']) . '", "' .
			   $con->escapeStr($user_doap_url_key) . '", "' .
			   $con->escapeStr($_POST['doap_maintainer_name']) . '", "' .
			   $con->escapeStr($_POST['doap_maintainer_nickname']) . '", "' .
			   $con->escapeStr($user_doap_maintainer_email) . '", "' .
			   $con->escapeStr($_POST['doap_maintainer_foaf_url']) . '", "' .
			   $con->escapeStr($user_doap_developers) . '", "' .
			   $con->escapeStr($user_doap_documenters) . '", "' .
			   $con->escapeStr($user_doap_translators) . '")';		   		   
		    		    		    		   		   		   
                } else {
                    $sql = 'UPDATE ' . DB_PREFIX . 'doap SET ' .		    		     
                          '`user_doap_lang`="' . $con->escapeStr($user_doap_lang) . '", ' .			   
			  '`user_doap_project_name`="' .$con->escapeStr($user_doap_project_name) . '", ' .
			  '`user_doap_release_name`="' .$con->escapeStr($user_doap_release_name) . '", ' .
			  '`user_doap_project_date`="' .date('Y-m-d',$user_doap_project_date) . '", ' .
                          '`user_doap_project_version`="' .$con->escapeStr($user_doap_project_version) . '", ' .
                          '`user_doap_url_homepage`="' . $con->escapeStr($user_doap_url_homepage) . '", ' .
                          '`user_doap_description`="' . $con->escapeStr($user_doap_description) . '", ' .
                          '`user_doap_shortdesc`="' . $con->escapeStr($user_doap_shortdesc) . '", ' .
			  '`user_doap_url_wiki`="' . $con->escapeStr($user_doap_url_wiki) . '", ' .
			  '`user_doap_url_blog`="' . $con->escapeStr($user_doap_url_blog) . '", ' .
			  '`user_doap_url_buglist`="' . $con->escapeStr($user_doap_url_buglist) . '", ' .
			  '`user_doap_url_mailinglist`="' . $con->escapeStr($user_doap_url_mailinglist) . '", ' .
			  '`user_doap_url_screenshots`="' . $con->escapeStr($user_doap_url_screenshots) . '", ' .
			  '`user_doap_programming_language`="' . $con->escapeStr($user_doap_programming_language) . '", ' .
			  '`user_doap_os`="'.$con->escapeStr($user_doap_os). '", ' .
			  '`user_doap_license`="' . $con->escapeStr($user_doap_license) . '", ' .
			  '`user_doap_project_type`="' . $con->escapeStr($user_doap_project_type) . '", ' .
			  '`user_doap_url_repos1`="' . $con->escapeStr($user_doap_url_repos1) . '", ' .
			  '`user_doap_url_repos2`="' . $con->escapeStr($user_doap_url_repos2) . '", ' .
			  '`user_doap_url_repos3`="' . $con->escapeStr($user_doap_url_repos3) . '", ' .
			  '`user_doap_url_base`="' . $con->escapeStr($user_doap_url_base) . '", ' .			  
			  '`user_doap_url_logo`="' . $con->escapeStr($user_doap_url_logo) . '", ' .
			  '`user_doap_url_key`="' . $con->escapeStr($user_doap_url_key) . '", ' .
			  '`user_doap_maintainer_name`="' . $con->escapeStr($user_doap_maintainer_name) . '", ' .
			  '`user_doap_maintainer_nickname`="' . $con->escapeStr($user_doap_maintainer_nickname) . '", ' .
			  '`user_doap_maintainer_email`="' . $con->escapeStr(trim($_POST['doap_maintainer_email'])) . '", ' .
			  '`user_doap_maintainer_foaf_url`="' . $con->escapeStr($user_doap_maintainer_foaf_url) . '", ' .
			  '`user_doap_developers`="' . $con->escapeStr($user_doap_developers) . '", ' .
			  '`user_doap_documenters`="' . $con->escapeStr($user_doap_documenters) . '", ' .
			  '`user_doap_translators`="' . $con->escapeStr($user_doap_translators) .'" ' .
                          'WHERE `user_doap_id`=' . $_POST['user_doap_id'];
                }                       
                       
                if (!$con->execute($sql)) {
                    if ($mode == 'add') {
                        $errors[] = __('Error adding DOAP project profile') . ' (' . $con->error() . ')';
                    } else {
                        $errors[] = __('Error editing DOAP project profile') . ' (' . $con->error() . ')';
                    }
                } else {
				
                    if (defined('DC_UPDATE_FILE_W') && DC_UPDATE_FILE_W) {
            			files::touch(DC_UPDATE_FILE, time());
    		        }
                    
		    $dcDoap = new dcDOAP($user_id,$user_doap_project_name,$user_doap_lang,dc_encoding);
		    
		    $dcDoap->_retrieveData();
		    
                    if ($mode == 'add') {
                        $blog->tiggerLog(DB_PREFIX.'doap', $con->getLastID(), 'Add a DOAP project profile,DOAP file generated');
                    } else {
                        $blog->tiggerLog(DB_PREFIX.'doap', $_POST['user_doap_id'], 'Edit a DOAP project profile,DOAP file regenerated');
                    }
                }
            }            
            
            if (count($errors) > 0) {
                $list = '<ul>';
    			foreach ($errors as $value) {
                    $list .= '<li>' . $value . '</li>';
                }
    			$list .= '</ul>';            
                buffer::str('<div class="erreur"><p><strong>' . __('Error(s)') . ' :</strong></p>' . $list . '</div>');
            } else {
                header('Location: ' . $plugin_url . '&mode=list');
            }
        } else { 
            if ($mode == 'add') {
	    			                
                buffer::str('<h2>' . __('Add a DOAP project profile') . '</h2>');
                						
		$rsUser = $blog->getUser($_SESSION['sess_user_id']);				
		
		$hidden_field = '';
				
		$user_doap_lang  = $rsUser->f('user_lang');
                $user_doap_project_name = !empty($_GET['doap_name'])?$_GET['doap_name']:'';
                $user_doap_project_version = !empty($_GET['doap_version'])?$_GET['doap_version']:'';
		$user_doap_release_name = !empty($_GET['doap_release_name'])?$_GET['doap_release_name']:$user_doap_project_name;
		$user_doap_project_date = date('Y-m-d',time());
                $user_doap_url_homepage ='http://'.$_SERVER['HTTP_HOST'].dc_blog_url;
                $user_doap_description = !empty($_GET['doap_version'])?$_GET['doap_shortdesc']:'';
		$user_doap_shortdesc  = !empty($_GET['doap_version'])?$_GET['doap_shortdesc']:'';				
	        $user_doap_url_wiki = '';
		$user_doap_url_blog = 'http://'.$_SERVER['HTTP_HOST'].dc_app_url;
		$user_doap_url_buglist = !empty($_GET['doap_url_buglist'])?$_GET['doap_url_buglist']:'';
		$user_doap_url_mailinglist = !empty($_GET['doap_url_mailinglist'])?$_GET['doap_url_mailinglist']:'';
		$user_doap_url_screenshots  =!empty($_GET['doap_screenshots'])?$_GET['doap_screenshots']:'http://'.$_SERVER['HTTP_HOST'].dc_app_url.'/images/';
		$user_doap_programming_language	  = 'PHP';
		$user_doap_license = 'http://usefulinc.com/doap/licenses/gpl';
		$user_doap_os = '';
		$user_doap_project_type = 'DOTCLEAR';
		$user_doap_url_repos1 = !empty($_GET['doap_url_repos1'])?$_GET['doap_url_repos1']:'';
		$user_doap_url_repos2 = !empty($_GET['doap_url_repos2'])?$_GET['doap_url_repos2']:'';
		$user_doap_url_repos3 = !empty($_GET['doap_url_repos3'])?$_GET['doap_url_repos3']:'';
		$user_doap_url_base = !empty($_GET['doap_url_base'])?$_GET['doap_url_base']:'';
		$user_doap_url_logo = !empty($_GET['doap_url_logo'])?$_GET['doap_url_logo']:'';
		$user_doap_url_key = !empty($_GET['doap_url_key'])?$_GET['doap_url_key']:'';
		$user_doap_maintainer_name = !empty($_GET['doap_maintainer_name'])?$_GET['doap_maintainer_name']:$rsUser->f('user_nom').' '.$rsUser->f('user_prenom');
		$user_doap_maintainer_nickname=$rsUser->f('user_pseudo');
		$user_doap_maintainer_email = $rsUser->f('user_email');
		$user_doap_maintainer_foaf_url = 'http://'.$_SERVER['HTTP_HOST'].dc_app_url.'/foaf.rdf';
		$user_doap_developers = $rsUser->f('user_nom').' '.$rsUser->f('user_prenom');
		$user_doap_documenters = $rsUser->f('user_nom').' '.$rsUser->f('user_prenom');
		$user_doap_translators = $rsUser->f('user_nom').' '.$rsUser->f('user_prenom');		                
		$button_caption = __('Add');
                $delete_button = '';
		
		$email_encrypt =__('DOAP Maintainer email,note : sha1 encrypted');
		
            } else {
                buffer::str('<h2>' . __('Edit a Doap Project profile') . '</h2>');
		
                $hidden_field = '<p class="field">' . form::hidden('user_doap_id', $_GET['user_doap_id']) . '</p>';
                                
                $rs = $con->select('SELECT * FROM '.DB_PREFIX.'doap WHERE user_doap_id = "'.$_GET['user_doap_id'].'"'); 
		
		$user_doap_lang  = $rs->field('user_doap_lang');
                $user_doap_project_name = $rs->field('user_doap_project_name');
                $user_doap_project_version = $rs->field('user_doap_project_version');
		$user_doap_release_name = $rs->field('user_doap_release_name');		
		$date_project = strtotime($rs->field('user_doap_project_date'));
		$user_doap_project_date = date('Y-m-d',$date_project);
                $user_doap_url_homepage =$rs->field('user_doap_url_homepage');
                $user_doap_description = $rs->field('user_doap_description');
		$user_doap_shortdesc  = $rs->field('user_doap_shortdesc');				
	        $user_doap_url_wiki = $rs->field('user_doap_url_wiki');
		$user_doap_url_blog = $rs->field('user_doap_url_blog');
		$user_doap_url_buglist = $rs->field('user_doap_url_buglist');
		$user_doap_url_mailinglist = $rs->field('user_doap_url_mailinglist');
		$user_doap_url_screenshots =$rs->field('user_doap_url_screenshots');
		$user_doap_programming_language	= $rs->field('user_doap_programming_language');
		$user_doap_os = $rs->field('user_doap_os');
		$user_doap_license = $rs->field('user_doap_license');
		$user_doap_project_type =$rs->field('user_doap_project_type');
		$user_doap_url_repos1 = $rs->field('user_doap_url_repos1');
		$user_doap_url_repos2 = $rs->field('user_doap_url_repos2');
		$user_doap_url_repos3 = $rs->field('user_doap_url_repos3');
		$user_doap_url_base = $rs->field('user_doap_url_base');
		$user_doap_url_logo = $rs->field('user_doap_url_logo');
		$user_doap_url_key = $rs->field('user_doap_url_key');
		$user_doap_maintainer_name = $rs->field('user_doap_maintainer_name');
		$user_doap_maintainer_nickname= $rs->field('user_doap_maintainer_nickname');
		$user_doap_maintainer_email = $rs->field('user_doap_maintainer_email');
		$user_doap_maintainer_foaf_url = $rs->field('user_doap_maintainer_foaf_url');
		$user_doap_developers = $rs->field('user_doap_developers');
		$user_doap_documenters = $rs->field('user_doap_documenters');
		$user_doap_translators = $rs->field('user_doap_translators');
		
		$email_encrypt = __('DOAP Maintainer email,note : do not modify');
					
                $button_caption = __('Edit');
                $delete_button = '&nbsp;<input name="delete" type="submit" class="submit" value="' . __('Delete') . '" onclick="return window.confirm(\'' .
		   __('Are you sure you want to delete this DOAP project profile ?') . '\')" />';               
	    }
            
            buffer::str(
            	'<form action="' . $plugin_url . '" method="post">'.
            	'<fieldset><legend>'.__('DOAP base : must not be empty').'</legend>'.	
            	'<p class="field"><label for="doap_lang"><strong>' . __('Language') . '&nbsp;:&nbsp;</strong>'. helpLink('index&amp;plugin=dcDOAP', 'field doap_lang') .
		'</label>'. form::combo('doap_lang',array('fr'=>'fr','en'=>'en','de'=>'de','es'=>'es'),$user_doap_lang) . '</p>' .	
            	'<p class="field"><label for="doap_name"><strong>' . __('DOAP project name') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_name').
		'</label>'.form::field('doap_name', 62, 255, $user_doap_project_name) . '</p>' .
            	'<p class="field"><label for="doap_version"><strong>' . __('DOAP Project version') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_version') .
		'</label>'.form::field('doap_version', 62,255, $user_doap_project_version) . '</p>' .
            	'<p class="field"><label for="doap_release_name"><strong>' . __('DOAP release name') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_release_name').
		'</label>'.form::field('doap_release_name', 62, 255, $user_doap_release_name) . '</p>' .
		'<p class="field"><label for="doap_project_date"><strong>' . __('DOAP project creation date') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_project_date').
		'</label>'.form::field('doap_project_date', 11, 10, $user_doap_project_date) . '</p>' .
		'<p class="field"><label for="doap_homepage"><strong>' . __('DOAP project Homepage') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_homepage') . 
		'</label>' .form::field('doap_homepage', 62, 255, $user_doap_url_homepage) . '</p>' .
                 '<p class="field"><label for="doap_description"><strong>' . __('DOAP Project long description') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_description') . 
		'</label>' .form::textArea('doap_description', 60, 10, $user_doap_description) . '</p>'.
		'<p class="field"><label for="doap_shortdesc"><strong>' . __('DOAP Project short description') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_shortdesc').
		'</label>'.form::field('doap_shortdesc', 62,255 , $user_doap_shortdesc) . '</p>' .
		'<p class="field"><label for="doap_maintainer_name"><strong>' . __('DOAP Maintainer Name (Project Leader)') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_maintainer_name') . 
		'</label>' .form::field('doap_maintainer_name', 62, 255, $user_doap_maintainer_name) . '</p>'.
                '<p class="field"><label for="doap_maintainer_nickname"><strong>' . __('DOAP Maintainer Nickname') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_maintainer_nickname').
		'</label>'.form::field('doap_maintainer_nickname', 62, 255, $user_doap_maintainer_nickname) . '</p>' .
            	'<p class="field"><label for="doap_maintainer_email"><strong>' .$email_encrypt  . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_maintainer_email') .
		'</label>'.form::field('doap_maintainer_email', 62,255, $user_doap_maintainer_email) . '</p>' .
            	'<p class="field"><label for="doap_maintainer_foaf_url"><strong>' . __('DOAP Maintainer foaf url') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_maintainer_foaf_url') . 
		'</label>'.form::field('doap_maintainer_foaf_url', 62,255, $user_doap_maintainer_foaf_url) . '</p>' .
		'<p class="field"><label for="doap_os"><strong>' . __('DOAP empty field means any os') . '&nbsp;:</strong>&nbsp;<em>(' . __('can be empty') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_os') . 
		'</label>'.form::field('doap_os', 62,255, $user_doap_os) . '</p>' .
		'<p class="field"><label for="doap_programming_language"><strong>' . __('DOAP programming language'). '&nbsp;:&nbsp;</strong>'.helpLink('index&amp;plugin=dcDOAP', 'field doap_programming_language') . 
		'</label>'.form::multicombo('doap_programming_language',array('PHP'=>'PHP','Flash'=>'Flash','Java'=>'Java','Python'=>'Python','Perl'=>'Perl','C++'=>'C++','C#'=>'C#','C'=>'C',
                'Ada'=>'Ada','Objective-C'=>'Objective-C','Rebol'=>'Rebol'),4,true,$user_doap_programming_language) . '</p>' .
                '<p class="field"><label for="doap_license"><strong>' . __('DOAP Project license').'<br />'.__('(DotClear use GNU/GPL v2 License)').'&nbsp;:&nbsp;</strong>'. helpLink('index&amp;plugin=dcDOAP', 'field doap_license') . 
		'</label>' .form::multicombo('doap_license',array('GNU/GPL 2'=>'http://usefulinc.com/doap/licenses/gpl','GNU/LGPL 2.1'=>'http://usefulinc.com/doap/licenses/lgpl','BSD'=>'http://usefulinc.com/doap/licenses/bsd',
		'Artistic'=>'http://usefulinc.com/doap/licenses/artistic','Apache License 2.0'=>'http://usefulinc.com/doap/licenses/asl20','Mozilla Public License'=>'http://usefulinc.com/doap/licenses/mpl'),4,true,$user_doap_license) . '</p>'.		
		'<p class="field"><label for="doap_project_type"><strong>' . __('DOAP Project Type') .'&nbsp;:&nbsp;</strong>'. helpLink('index&amp;plugin=dcDOAP', 'field doap_project_type') . 
		'</label>' .form::combo('doap_project_type',array('DotClear Plugin'=>'DOTCLEAR','Cvs repository'=>'CVS','Svn repository'=>'SVN','Arch Repository'=>'ARCH','Bitkeeper repository'=>'BITKEEPER'),$user_doap_project_type) . '</p>'.
                '<p class="field"><label for="doap_url_repos1"><strong>' . __('DOAP anonymous server string or pkg gz url') . '&nbsp;:</strong>&nbsp;'.helpLink('index&amp;plugin=dcDOAP', 'field doap_url_repos1').
		'<br /><em>(' . __('MUST be empty for').' Arch,Svn,Bitkeeper' . ')</em>&nbsp;' . '</label>'.form::field('doap_url_repos1', 62, 255, $user_doap_url_repos1) . '</p>' .
            	'<p class="field"><label for="doap_url_repos2"><strong>' . __('DOAP module name or zip url') . '&nbsp;:</strong>&nbsp;'. helpLink('index&amp;plugin=dcDOAP', 'field doap_url_repos2') .
		'<br /><em>(' . __('MUST be empty for').' Svn,Bitkeeper' . ')</em>&nbsp;'.'</label>'.form::field('doap_url_repos2', 62,255, $user_doap_url_repos2) . '</p>' .            	
		'<p class="field"><label for="doap_url_repos3"><strong>' . __('DOAP web interface or targz url') . '&nbsp;:</strong>&nbsp;'.helpLink('index&amp;plugin=dcDOAP', 'field doap_url_repos3').
		'<br /><em>(' . __('MUST be empty for').' Arch' . ')</em>&nbsp;' .'</label>'.form::field('doap_url_repos3', 62, 255, $user_doap_url_repos3) . '</p>' .
		'<p class="field"><label for="doap_url_base"><strong>' . __('DOAP base url') . '&nbsp;:</strong>&nbsp;'.helpLink('index&amp;plugin=dcDOAP', 'field doap_url_base').
		'<br /><em>(' . __('MUST be empty for').' Cvs' . ')</em>&nbsp;' .'</label>'.form::field('doap_url_base', 62, 255, $user_doap_url_base) . '</p>' .
		'</fieldset>'.
		'<fieldset> <legend>'.__('DOAP extra fields : some fields may be empty').'</legend>'.		
		'<p class="field"><label for="doap_url_wiki"><strong>' . __('DOAP url wiki') . '&nbsp;:</strong>&nbsp;<em>(' . __('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_url_wiki').
		'</label>'.form::field('doap_url_wiki', 62, 255, $user_doap_url_wiki) . '</p>' .
		'<p class="field"><label for="doap_url_blog"><strong>' . __('DOAP url blog') . '&nbsp;:</strong>&nbsp;<em>(' . __('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_url_blog').
		'</label>'.form::field('doap_url_blog', 62, 255, $user_doap_url_blog) . '</p>' .
		'<p class="field"><label for="doap_url_buglist"><strong>' . __('DOAP url buglist') . '&nbsp;:</strong>&nbsp;<em>(' . __('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_url_buglist').
		'</label>'.form::field('doap_url_buglist', 62, 255, $user_doap_url_buglist) . '</p>' .
		'<p class="field"><label for="doap_url_mailinglist"><strong>' . __('DOAP url mailinglist') . '&nbsp;:</strong>&nbsp;<em>(' . __('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_url_mailinglist').
		'</label>'.form::field('doap_url_mailinglist', 62, 255, $user_doap_url_mailinglist) . '</p>' .		
            	'<p class="field"><label for="doap_screenshots"><strong>' . __('DOAP url screenshots').'&nbsp;:</strong>&nbsp;<em>(' . __('optional') . ')</em>&nbsp;' .helpLink('index&amp;plugin=dcDOAP', 'field doap_url_screenshots') .
		'</label>'.form::field('doap_screenshots', 62,255, $user_doap_url_screenshots) . '</p>' .            	
            	'<p class="field"><label for="doap_url_logo"><strong>' . __('DOAP Project logo url') . '&nbsp;:</strong>&nbsp;<em>(' . __('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_url_logo') .
		'</label>'.form::field('doap_url_logo', 62,255, $user_doap_url_logo) . '</p>' .
            	'<p class="field"><label for="doap_url_key"><strong>' . __('DOAP Project key url') . '&nbsp;:</strong>&nbsp;<em>(' . __('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP', 'field doap_url_key') . 
		'</label>' .form::field('doap_url_key', 62, 255, $user_doap_url_key) . '</p>' . 
		'<p class="field"><label for="doap_developer"><strong>' . __('DOAP Developer(s) contributor(s)') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP','field doap_developers') . 
		'</label>' .form::field('doap_developers', 62, 255,$user_doap_developers) . '</p>'.                
		'<p class="field"><label for="doap_documenters"><strong>' . __('DOAP Documenter(s) contributor(s)') . '&nbsp;:</strong>&nbsp;<em>(' . __('not optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=dcDOAP','field doap_documenters') . 
		'</label>' .form::field('doap_documenters', 62, 255,$user_doap_documenters) . '</p>'.
		'<p class="field"><label for="doap_translators"><strong>' . __('DOAP Translator(s) contributor(s)') . '&nbsp;:</strong>&nbsp;<em>(' . __('optional') . ')</em>&nbsp;' .helpLink('index&amp;plugin=dcDOAP', 'field doap_translators') . 
		'</label>' .form::field('doap_translators', 62, 255, $user_doap_translators) . '</p>'.
		$hidden_field . 
		'<p class="field">' . form::hidden('doap_submited', true) . '</p>' .		
		'</fieldset>'.
                '<p class="field">' . 
                '<input name="' . $mode . '" type="submit" class="submit" value="' . $button_caption . '" />' .
                $delete_button .               
                '</p>' .
            	'</form>'
            );
        }        
        break;
    }
    
    case 'delete':
    {     
    
       	$sql = 'DELETE FROM ' . DB_PREFIX . 'doap WHERE `user_doap_id`=' . $_POST['user_doap_id'];
		
        if (!$con->execute($sql)) {
            buffer::str('<div class="erreur"><p><strong>' . __('Error(s)') . ' :</strong></p>' . __('Error removing DOAP entry') .$con->error(). '</div>');
        } else {
            if (defined('DC_UPDATE_FILE_W') && DC_UPDATE_FILE_W) {
    			files::touch(DC_UPDATE_FILE, time());
            }
	    
            $dcDoap = new dcDOAP($_SESSION['sess_user_id'],$_POST['doap_name'],$_POST['doap_lang'],dc_encoding);
		    
            $dcDoap->_eraseDOAPFile();
	    
	    $blog->tiggerLog(DB_PREFIX.'doap',$_POST['doap_name'] , 'A DOAP project profile has been deleted');
            
	    
	   header('Location: ' . $plugin_url . '&mode=list');
        }    
        break;
    }       
         
    case 'install':
    {
       include_once dirname(__FILE__).'/install/index.php';
       break;
    }
    case 'uninstall':
    {
       include_once dirname(__FILE__).'/uninstall/index.php';
       break;
    }   
}

?>
